Object subclass: #ERobot
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ERobot methodsFor: 'private' stamp: 'Casco 6/8/2015 21:39'!
step
   Transcript show: 'Robot (', self name, ')'; cr.
	Transcript tab.
	self move.
	Transcript tab.
	self consumeBattery.
	Transcript tab.
	self fireArms.
	Transcript tab.
	self collectArtifacts! !


!ERobot methodsFor: 'accessing' stamp: 'Casco 6/8/2015 21:56'!
name: aString
  name := aString! !

!ERobot methodsFor: 'accessing' stamp: 'Casco 6/8/2015 21:56'!
name
  ^name ! !


!ERobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:42'!
collectArtifacts
  Transcript show: ' COLLECTING'; cr.

! !

!ERobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:22'!
move
  self subclassResponsibility ! !

!ERobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:22'!
consumeBattery
  self subclassResponsibility 

! !

!ERobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:22'!
fireArms
  self subclassResponsibility 

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ERobot class
	instanceVariableNames: ''!

!ERobot class methodsFor: 'instance creation' stamp: 'Casco 6/8/2015 21:56'!
named: aString
	^ self new
		name: aString;
		yourself! !


ERobot subclass: #ENuclearRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
consumeBattery
	Transcript
		show: ' consuming NUCLEAR energy';
		cr! !


ERobot subclass: #ESolarRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:36'!
consumeBattery
	Transcript show: ' consuming SOLAR energy'; cr.! !


ESolarRobot subclass: #ESolarOvercraftRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarOvercraftRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:47'!
move
	Transcript
		show: ' moving on OVERCRAFT';
		cr! !


ESolarOvercraftRobot subclass: #ESolarOvercraftRobotWithLasers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarOvercraftRobotWithLasers methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:49'!
fireArms
	Transcript
		show: ' firing LASERS';
		cr! !


ESolarOvercraftRobot subclass: #ESolarOvercraftRobotWithBombs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarOvercraftRobotWithBombs methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:49'!
fireArms
	Transcript
		show: ' firing BOMBS';
		cr! !


ESolarRobot subclass: #ESolarCaterpillarRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarCaterpillarRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:47'!
move
	Transcript
		show: ' moving on CATERPILLAR';
		cr! !


ESolarCaterpillarRobot subclass: #ESolarCaterpillarRobotWithLasers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarCaterpillarRobotWithLasers methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:49'!
fireArms
	Transcript
		show: ' firing LASERS';
		cr! !


ESolarCaterpillarRobot subclass: #ESolarCaterpillarRobotWithBombs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ESolarCaterpillarRobotWithBombs methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:49'!
fireArms
	Transcript
		show: ' firing BOMBS';
		cr! !


ENuclearRobot subclass: #ENuclearOvercraftRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearOvercraftRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
move
	Transcript
		show: ' moving on OVERCRAFT';
		cr! !


ENuclearOvercraftRobot subclass: #ENuclearOvercraftRobotWithLasers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearOvercraftRobotWithLasers methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
fireArms
	Transcript
		show: ' firing LASERS';
		cr! !


ENuclearOvercraftRobot subclass: #ENuclearOvercraftRobotWithBombs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearOvercraftRobotWithBombs methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
fireArms
	Transcript
		show: ' firing BOMBS';
		cr! !


Object subclass: #EGameBoard
	instanceVariableNames: 'robots running cycle maxCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!EGameBoard methodsFor: 'robots' stamp: 'Casco 6/8/2015 21:59'!
add: aRobot
  robots add: aRobot.! !


!EGameBoard methodsFor: 'private' stamp: 'Casco 6/8/2015 22:10'!
step
   
   robots do: [ :each | each step].
! !

!EGameBoard methodsFor: 'private' stamp: 'Casco 6/8/2015 21:23'!
waitUntilNextStep
  (Delay forSeconds: 5) wait. ! !

!EGameBoard methodsFor: 'private' stamp: 'Casco 6/8/2015 22:17'!
run
	| process |
	running := true.
	process := [ 
	[ running & (cycle <= maxCycles) ]
		whileTrue: [ 
			Transcript
				show: '-----------CICLE:' , cycle printString , '-------------';
				cr.
			self step.
			cycle := cycle + 1.
			self waitUntilNextStep ] ] fork! !


!EGameBoard methodsFor: 'starting/stopping' stamp: 'Casco 6/8/2015 22:15'!
runForCycles: aNumber
  maxCycles := aNumber. 
  self run.! !

!EGameBoard methodsFor: 'starting/stopping' stamp: 'Casco 6/8/2015 21:15'!
stop

	running := false.
! !

!EGameBoard methodsFor: 'starting/stopping' stamp: 'Casco 6/8/2015 22:15'!
runUntilStopped
  maxCycles := Float infinity . 
  self run.! !


!EGameBoard methodsFor: 'initialization' stamp: 'Casco 6/8/2015 22:12'!
initialize
	running := false.
	cycle := 1.
	robots := Set new! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

EGameBoard class
	instanceVariableNames: ''!

!EGameBoard class methodsFor: 'initialize' stamp: 'Casco 6/8/2015 22:40'!
showTranscript
   Smalltalk tools openTranscript ! !

!EGameBoard class methodsFor: 'initialize' stamp: 'Casco 6/8/2015 23:05'!
initialize
   EGameBoard  browse.
   self openExamplePlayground. 
   self showTranscript. 
! !

!EGameBoard class methodsFor: 'initialize' stamp: 'Casco 6/8/2015 22:59'!
openExamplePlayground
   | contents |
contents := '| game |
"Creo el juego"
game := EGameBoard new.

"Agrego un robot, con energia nuclear, orugas, y bombas - le llamo R2D2"
game add: (ENuclearCaterpillarRobotWithBombs named: ''R2D2'').

"Agrego un robot, con energia nuclear, aerodeslizador, y lasers - le llamo C3PO"
game add: (ENuclearOvercraftRobotWithLasers named: ''C3PO'').

"Le digo al juego que juege por solo dos ciclos - pasos"
"Entre ciclos espera aprox 5 segundos"
game runForCycles: 2.'.
	GTPlayground openContents: contents label: 'Example using inheritance'! !


ENuclearRobot subclass: #ENuclearCaterpillarRobot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearCaterpillarRobot methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
move
	Transcript
		show: ' moving on CATERPILLAR';
		cr! !


ENuclearCaterpillarRobot subclass: #ENuclearCaterpillarRobotWithLasers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearCaterpillarRobotWithLasers methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:45'!
fireArms
	Transcript
		show: ' firing LASERS';
		cr! !


ENuclearCaterpillarRobot subclass: #ENuclearCaterpillarRobotWithBombs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Hotspots-Inheritance'!

!ENuclearCaterpillarRobotWithBombs methodsFor: 'hooks' stamp: 'Casco 6/8/2015 21:46'!
fireArms
	Transcript
		show: ' firing BOMBS';
		cr! !

EGameBoard initialize!